/**
 * <copyright>
 * </copyright>
 */
package com.auchan.proto.frontend;

import org.eclipse.core.runtime.IStatus;

import com.auchan.proto.frontend.transforms.MainTransform;
import com.ibm.xtools.transform.authoring.JETRule;
import com.ibm.xtools.transform.authoring.RootTransformation;
import com.ibm.xtools.transform.authoring.TransformationProvider;
import com.ibm.xtools.transform.core.AbstractTransform;
import com.ibm.xtools.transform.core.ITransformContext;
import com.ibm.xtools.transform.core.ITransformationDescriptor;

/**
 * An implementation of a transformation provider for the '<em><b>ProtoAuchanTransformation</b></em>'.
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * @generated
 */
public class ProtoAuchanTransformationProvider extends TransformationProvider {

   /**
     * The transformation id
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public static final String TRANSFORMATION = "com.auchan.proto.frontend.ProtoAuchanTransformation";//$NON-NLS-1$

   /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see com.ibm.xtools.transform.core.AbstractTransformationProvider#createTransformation(com.ibm.xtools.transform.core.ITransformationDescriptor)
     * @generated
     */
	public AbstractTransform createTransformation(ITransformationDescriptor descriptor) {
        RootTransformation transform = null;
        if (TRANSFORMATION.equals(descriptor.getId())) {
            transform = createRootTransformation(descriptor);
       	}
        return transform;
    }

	/**
	 * Creates a root transformation. You may add more rules to the
	 * transformation here <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param transform
	 *            The root transformation
	 */
	protected RootTransformation createRootTransformation(
			ITransformationDescriptor descriptor) {
		return new RootTransformation(descriptor, new MainTransform()) {
			protected void addPostProcessingRules() {
				add(new JETRule("com.auchan.proto.codegen"));
			}
		};
	}

   /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see com.ibm.xtools.transform.core.AbstractTransformationProvider#validateContext(com.ibm.xtools.transform.core.ITransformationDescriptor, com.ibm.xtools.transform.core.ITransformContext)
     * @generated
     */
	public IStatus validateContext(ITransformationDescriptor descriptor, ITransformContext context) {
        if (TRANSFORMATION.equals(descriptor.getId()))
           return ProtoAuchanTransformationValidator.INSTANCE.isValid(context);
        return null;
    }

}
