package com.auchan.proto.frontend.custom;

import org.eclipse.core.resources.IMarker;
import org.eclipse.emf.query.conditions.Condition;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;

public class Class2MetierFilter extends Condition {

	@Override
	public boolean isSatisfied(Object object) {
		Util.log("Class2MetierFilter", object);
		// Le custom extractor garantit que l'objet en entre est une classe <<metier>> 
		Class curCl = (Class) object;
		Stereotype st = curCl.getAppliedStereotype("ProtoAuchan::metier");
		boolean valid = true;
		// La classe "metier" doit avoir le champ Table du strotype dfini
		String s = (String) curCl.getValue(st, "table");
		if (s == null || s.equals("")) {
			Util.addMarker(curCl.getNamespace(), "La classe mtier '" + curCl.getName() + "' (dans '" + curCl.getNamespace().getName() + //$NON-NLS-1$ //$NON-NLS-2$
				"') n'a pas le champ 'table' du strotype 'metier' dfini. Cette classe a t ignore.", //$NON-NLS-1$
				IMarker.SEVERITY_ERROR);
			valid = false;
		}
		// La classe "metier" doit avoir un attribut strotyp "id"
		valid = false;
		for (Object curAtt_o : curCl.getOwnedAttributes()) {
			Property curAtt = (Property) curAtt_o;
			if (curAtt.getAppliedStereotype("ProtoAuchan::id") != null) {
				valid = true;
				break;
			}
		}
		if (!valid) {
			Util.addMarker(curCl.getNamespace(), "La classe mtier '" + curCl.getName() + "' (dans '" + curCl.getNamespace().getName() + //$NON-NLS-1$ //$NON-NLS-2$
				"') doit avoir un attribut strotyp <<id>>. La classe a t ignore.", //$NON-NLS-1$
				IMarker.SEVERITY_ERROR);
		}			
		return valid;
	}

}
