package com.auchan.proto.frontend.custom;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.UMLPackage;

import com.ibm.xtools.transform.authoring.ExtractorExtension;

public class PackageableElt2MetierExtractor implements ExtractorExtension {

	public Collection execute(EObject arg0) {
		Util.log("PackageableElt2MetierExtractor", arg0);
		Model inModel = (Model) arg0;
		List<Class> c = new ArrayList<Class>();
		processPackage(inModel, c);
		return c;
	}

	private void processPackage(Package inPkg, List<Class> inList) {
		List<EObject> allClasses = Util.findElements(inPkg, UMLPackage.eINSTANCE.getClass_());
		for (EObject o : allClasses) {
			Class cl = (Class) o;
			if (cl.getAppliedStereotype("ProtoAuchan::metier") != null) inList.add(cl);
		}	
	}
	
}
