/**
 * <copyright>
 * </copyright>
 */
package com.auchan.proto.frontend.transforms;


import com.auchan.proto.frontend.custom.Class2MetierFilter;
import com.auchan.proto.frontend.custom.PackageableElt2MetierExtractor;

import com.auchan.proto.frontend.l10n.ProtoAuchanMessages;

import com.auchan.proto.frontend.transforms.Class2MetierTransform;

import com.ibm.xtools.transform.authoring.CreateRule;
import com.ibm.xtools.transform.authoring.CustomExtractor;
import com.ibm.xtools.transform.authoring.DirectFeatureAdapter;
import com.ibm.xtools.transform.authoring.FeatureAdapter;
import com.ibm.xtools.transform.authoring.InstanceOfCondition;
import com.ibm.xtools.transform.authoring.MapTransform;
import com.ibm.xtools.transform.authoring.MoveRule;
import com.ibm.xtools.transform.authoring.Registry;

import com.ibm.xtools.transform.core.AbstractContentExtractor;
import com.ibm.xtools.transform.core.AbstractRule;

import inputSchema.InputSchemaPackage;

import org.eclipse.emf.query.conditions.Condition;

import org.eclipse.uml2.uml.UMLPackage; 


/**
 * <!-- begin-user-doc -->
 * An implementation of the 'Model2ProjetTransform' from the mapping.
 * <!-- end-user-doc -->
 * @generated
 */
public class Model2ProjetTransform extends MapTransform {

    /**
     * The transform id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String TRANSFORM = "Model2Projet_Transform";//$NON-NLS-1$

   /**
     * The create rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String CREATE_RULE = TRANSFORM + "_Create_Rule";//$NON-NLS-1$

   /**
     * The 'Name To Nom' rule id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String NAME_TO_NOM_RULE = TRANSFORM + "_NameToNom_Rule";//$NON-NLS-1$
	
   /**
     * The 'PackagedElement To Metier Using Class2Metier' extractor id
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final String PACKAGED_ELEMENT_TO_METIER_USING_CLASS2METIER_EXTRACTOR = TRANSFORM + "_PackagedElementToMetier_UsingClass2Metier_Extractor";//$NON-NLS-1$
	
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Model2ProjetTransform(Registry registry, FeatureAdapter referenceAdapter) {
        super(TRANSFORM, ProtoAuchanMessages.Model2Projet_Transform, registry, referenceAdapter);
        addTransformElements(registry);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addTransformElements(Registry registry) {
    	// You may add more transform element before the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    	addGeneratedTransformElements(registry);
    	// You may add more transform element after the generated ones here
    	// Remember to remove the @generated tag or add NOT to it
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void addGeneratedTransformElements(Registry registry) {
        add(getNameToNom_Rule());				
        add(getPackagedElementToMetier_UsingClass2Metier_Extractor(registry));				
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Condition getAccept_Condition() {
        return new InstanceOfCondition(UMLPackage.Literals.MODEL);
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CreateRule getCreate_Rule(FeatureAdapter referenceAdapter) {
        CreateRule rule = new CreateRule(
            CREATE_RULE, 
            ProtoAuchanMessages.Model2Projet_Transform_Create_Rule, 
            this,
            referenceAdapter,
            InputSchemaPackage.Literals.PROJET); 
            
        return rule;    
    }

   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractRule getNameToNom_Rule() {
        MoveRule rule = new MoveRule(
            NAME_TO_NOM_RULE, 
            ProtoAuchanMessages.Model2Projet_Transform_NameToNom_Rule,
            new DirectFeatureAdapter(UMLPackage.Literals.NAMED_ELEMENT__NAME), 
            new DirectFeatureAdapter(InputSchemaPackage.Literals.PROJET__NOM));
			
        return rule;            
    }
					
   /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbstractContentExtractor getPackagedElementToMetier_UsingClass2Metier_Extractor(Registry registry) {
        CustomExtractor extractor = new CustomExtractor(
            PACKAGED_ELEMENT_TO_METIER_USING_CLASS2METIER_EXTRACTOR, 
            ProtoAuchanMessages.Model2Projet_Transform_PackagedElementToMetier_UsingClass2Metier_Extractor, 
            registry.get(Class2MetierTransform.class, new DirectFeatureAdapter(InputSchemaPackage.Literals.PROJET__METIER)),
            new PackageableElt2MetierExtractor());
			
        extractor.setFilterCondition(new Class2MetierFilter());

        return extractor;
    }
					
}
