/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| Copyright IBM Corp. 2003, 2005.  All Rights Reserved.                  |  
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

package com.auchan.proto.patterns.ecranpopupcombo;

import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Stereotype;

import com.auchan.proto.patterns.custom.PatternUtil;
import com.ibm.xtools.patterns.framework.AbstractPatternLibrary;
import com.ibm.xtools.patterns.framework.PatternIdentity;
import com.ibm.xtools.patterns.framework.PatternParameterValue.Proposed;
import com.ibm.xtools.patterns.framework.uml2.AbstractPatternDefinition;

import com.ibm.xtools.patterns.framework.PatternParameterIdentity;
import com.ibm.xtools.patterns.framework.uml2.AbstractPatternParameter;
import com.ibm.xtools.patterns.framework.PatternParameterValue;

/**
 * This class implements the Ecran Popup Combo, it extends
 * from the abstract pattern definition base class to gain most of the functionality needed to make
 * pattern definition specification in code easier.   
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class EcranPopupCombo extends AbstractPatternDefinition {
	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final static String PATTERN_ID = "com.auchan.proto.patterns.ecranpopupcombo.EcranPopupCombo"; //$NON-NLS-1$

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final static String PATTERN_VER = "1.0.0"; //$NON-NLS-1$

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final Ecran ecran = new Ecran();

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final Popup popup = new Popup();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EcranPopupCombo(AbstractPatternLibrary owningPatternLibrary) {
		super(
				new PatternIdentity(owningPatternLibrary, PATTERN_ID,
						PATTERN_VER)); // DO NOT EDIT
	}

	/**
	 * This class implements the Ecran, it extends
	 * from the abstract pattern parameter base class to gain most of the functionality needed to make
	 * pattern parameter specification in code easier.  
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private class Ecran extends AbstractPatternParameter {
		/**
		 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION 
		 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private final static String PARAMETER_ID = "Ecran"; //$NON-NLS-1$

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		Ecran() {
			super(EcranPopupCombo.this, new PatternParameterIdentity(
					PARAMETER_ID));// DO NOT EDIT

		}

		/**
		 * This is the default general expand method that is typically implemented
		 * by concrete pattern parameters for handling the added and maintained
		 * expand variants which are usually similar.
		 * 
		 * This method gets called during a pattern expansion for each new parameter 
		 * value that has been bound since last expansion, or for each existing value
		 * in a reapply scenerio.
		 * 
		 * The default behavior is to return true.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 */
		public boolean expand(PatternParameterValue value) {
			Class inCl = (Class) value.getValue();
			Model model = inCl.getModel();
			// Appliquer profile Auchan si pas dj fait
			Profile pa = model.getAppliedProfile("ProtoAuchan");
			if (pa == null) {
				pa = PatternUtil.applyAuchanProfile(model);
			}
			if (pa != null) {
				// Appliquer strotype <<ecran>> si pas dj fait
				Stereotype st = inCl.getAppliedStereotype("ProtoAuchan::ecran");
				if (st == null) {
					st = inCl.getApplicableStereotype("ProtoAuchan::ecran");
					if (st != null) inCl.applyStereotype(st);
				}
			}
			PatternUtil.processEcranWithPopup(value.getOwningInstance());
			return true;
		}

		@Override
		protected boolean isValid(Proposed arg0) {
			if (super.isValid(arg0)) {
				Class inCl = (Class) arg0.getValue();
				return (inCl.getAppliedStereotype("ProtoAuchan::metier") != null); 
			}
			return false;
		}
		
		/**
		 * The default behavior is to return true since removed value expansion is
		 * optional but it is recommended that pattern parameters support this for
		 * consistency with the patterns shipped in the product and a better user
		 * experience for the pattern applying user.
		 *
		 * This method gets called during a pattern expansion for each parameter 
		 * value that has been unbound since last expansion.  
		 *
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue.Removed value) {
			//TODO : implement the parameter's expand method
			return true;
		}

	}

	/**
	 * This class implements the Popup, it extends
	 * from the abstract pattern parameter base class to gain most of the functionality needed to make
	 * pattern parameter specification in code easier.  
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private class Popup extends AbstractPatternParameter {
		/**
		 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION 
		 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private final static String PARAMETER_ID = "Popup"; //$NON-NLS-1$

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		Popup() {
			super(EcranPopupCombo.this, new PatternParameterIdentity(
					PARAMETER_ID));// DO NOT EDIT

		}

		/**
		 * This is the default general expand method that is typically implemented
		 * by concrete pattern parameters for handling the added and maintained
		 * expand variants which are usually similar.
		 * 
		 * This method gets called during a pattern expansion for each new parameter 
		 * value that has been bound since last expansion, or for each existing value
		 * in a reapply scenerio.
		 * 
		 * The default behavior is to return true.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue value) {
			PatternUtil.processEcranWithPopup(value.getOwningInstance());
			return true;
		}
		
		@Override
		protected boolean isValid(Proposed arg0) {
			if (super.isValid(arg0)) {
				Class inCl = (Class) arg0.getValue();
				return (inCl.getAppliedStereotype("ProtoAuchan::metier") != null); 
			}
			return false;
		}

		/**
		 * The default behavior is to return true since removed value expansion is
		 * optional but it is recommended that pattern parameters support this for
		 * consistency with the patterns shipped in the product and a better user
		 * experience for the pattern applying user.
		 *
		 * This method gets called during a pattern expansion for each parameter 
		 * value that has been unbound since last expansion.  
		 *
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue.Removed value) {
			//TODO : implement the parameter's expand method
			return true;
		}

	}

}
