/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| Copyright IBM Corp. 2003, 2005.  All Rights Reserved.                  |  
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

package com.auchan.proto.patterns.metier;

import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StringExpression;

import com.auchan.proto.patterns.custom.PatternUtil;
import com.ibm.xtools.patterns.framework.AbstractPatternLibrary;
import com.ibm.xtools.patterns.framework.PatternIdentity;
import com.ibm.xtools.patterns.framework.uml2.AbstractPatternDefinition;

import com.ibm.xtools.patterns.framework.PatternParameterIdentity;
import com.ibm.xtools.patterns.framework.uml2.AbstractPatternParameter;
import com.ibm.xtools.patterns.framework.PatternParameterValue;

import com.ibm.xtools.patterns.framework.AbstractPatternDependency;

/**
 * This class implements the Metier, it extends
 * from the abstract pattern definition base class to gain most of the functionality needed to make
 * pattern definition specification in code easier.   
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class Metier extends AbstractPatternDefinition {
	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final static String PATTERN_ID = "com.auchan.proto.patterns.metier.Metier"; //$NON-NLS-1$

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final static String PATTERN_VER = "1.0.0"; //$NON-NLS-1$

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final Identifiant identifiant = new Identifiant();

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final NomTable nomTable = new NomTable();

	/**
	 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION
	 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final Entite entite = new Entite(this.identifiant, this.nomTable);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Metier(AbstractPatternLibrary owningPatternLibrary) {
		super(
				new PatternIdentity(owningPatternLibrary, PATTERN_ID,
						PATTERN_VER)); // DO NOT EDIT
	}

	/**
	 * This class implements the Identifiant, it extends
	 * from the abstract pattern parameter base class to gain most of the functionality needed to make
	 * pattern parameter specification in code easier.  
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private class Identifiant extends AbstractPatternParameter {
		/**
		 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION 
		 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private final static String PARAMETER_ID = "Identifiant"; //$NON-NLS-1$

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		Identifiant() {
			super(Metier.this, new PatternParameterIdentity(PARAMETER_ID));// DO NOT EDIT

		}

		/**
		 * This is the default general expand method that is typically implemented
		 * by concrete pattern parameters for handling the added and maintained
		 * expand variants which are usually similar.
		 * 
		 * This method gets called during a pattern expansion for each new parameter 
		 * value that has been bound since last expansion, or for each existing value
		 * in a reapply scenerio.
		 * 
		 * The default behavior is to return true.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 */
		public boolean expand(PatternParameterValue value) {
			Property inAtt = (Property) value.getValue();
			// Appliquer strotype <<id>> si pas dj fait
			Stereotype st = inAtt.getAppliedStereotype("ProtoAuchan::id");
			if (st == null) {
				st = inAtt.getApplicableStereotype("ProtoAuchan::id");
				if (st != null) inAtt.applyStereotype(st);
			}
			return true;
		}

		/**
		 * The default behavior is to return true since removed value expansion is
		 * optional but it is recommended that pattern parameters support this for
		 * consistency with the patterns shipped in the product and a better user
		 * experience for the pattern applying user.
		 *
		 * This method gets called during a pattern expansion for each parameter 
		 * value that has been unbound since last expansion.  
		 *
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue.Removed value) {
			//TODO : implement the parameter's expand method
			return true;
		}

	}

	/**
	 * This class implements the NomTable, it extends
	 * from the abstract pattern parameter base class to gain most of the functionality needed to make
	 * pattern parameter specification in code easier.  
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private class NomTable extends AbstractPatternParameter {
		/**
		 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION 
		 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private final static String PARAMETER_ID = "NomTable"; //$NON-NLS-1$

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		NomTable() {
			super(Metier.this, new PatternParameterIdentity(PARAMETER_ID));// DO NOT EDIT

		}

		/**
		 * This is the default general expand method that is typically implemented
		 * by concrete pattern parameters for handling the added and maintained
		 * expand variants which are usually similar.
		 * 
		 * This method gets called during a pattern expansion for each new parameter 
		 * value that has been bound since last expansion, or for each existing value
		 * in a reapply scenerio.
		 * 
		 * The default behavior is to return true.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue value) {
			//TODO : implement the parameter's expand method
			return true;
		}

		/**
		 * The default behavior is to return true since removed value expansion is
		 * optional but it is recommended that pattern parameters support this for
		 * consistency with the patterns shipped in the product and a better user
		 * experience for the pattern applying user.
		 *
		 * This method gets called during a pattern expansion for each parameter 
		 * value that has been unbound since last expansion.  
		 *
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue.Removed value) {
			//TODO : implement the parameter's expand method
			return true;
		}

	}

	/**
	 * This class implements the Entite, it extends
	 * from the abstract pattern parameter base class to gain most of the functionality needed to make
	 * pattern parameter specification in code easier.  
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private class Entite extends AbstractPatternParameter {
		/**
		 * DO NOT EDIT EXCEPT FOR THE USER DOC SECTION 
		 * NEEDS TO BE KEPT IN SYNC WITH THE PATTERN MANIFEST FILE
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private final static String PARAMETER_ID = "Entite"; //$NON-NLS-1$

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		Entite(Identifiant identifiant, NomTable nomTable) {
			super(Metier.this, new PatternParameterIdentity(PARAMETER_ID));// DO NOT EDIT

			new Entite_IdentifiantDependency(identifiant);

			new Entite_NomTableDependency(nomTable);

		}

		/**
		 * This is the default general expand method that is typically implemented
		 * by concrete pattern parameters for handling the added and maintained
		 * expand variants which are usually similar.
		 * 
		 * This method gets called during a pattern expansion for each new parameter 
		 * value that has been bound since last expansion, or for each existing value
		 * in a reapply scenerio.
		 * 
		 * The default behavior is to return true.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 */
		public boolean expand(PatternParameterValue value) {
			Class inCl = (Class) value.getValue();
			Model model = inCl.getModel();
			// Appliquer profile Auchan si pas dj fait
			Profile pa = model.getAppliedProfile("ProtoAuchan");
			if (pa == null) {
				pa = PatternUtil.applyAuchanProfile(model);
			}
			if (pa != null) {
				// Appliquer strotype <<metier>> si pas dj fait
				Stereotype st = inCl.getAppliedStereotype("ProtoAuchan::metier");
				if (st == null) {
					st = inCl.getApplicableStereotype("ProtoAuchan::metier");
					if (st != null) inCl.applyStereotype(st);
				}
			}
			return true;
		}

		/**
		 * The default behavior is to return true since removed value expansion is
		 * optional but it is recommended that pattern parameters support this for
		 * consistency with the patterns shipped in the product and a better user
		 * experience for the pattern applying user.
		 *
		 * This method gets called during a pattern expansion for each parameter 
		 * value that has been unbound since last expansion.  
		 *
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public boolean expand(PatternParameterValue.Removed value) {
			//TODO : implement the parameter's expand method
			return true;
		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private class Entite_IdentifiantDependency extends
				AbstractPatternDependency {
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			private Entite_IdentifiantDependency(
					AbstractPatternParameter dependency) {
				super(Entite.this, dependency);
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of new values that has been added to the dependent and dependency 
			 * parameter since last expansion as a result of binding a value to either 
			 * the dependent or dependency parameter. In a reapply scenerio, it gets 
			 * called for each pair of existing values bound to the parameters.
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			public boolean update(PatternParameterValue value,
					PatternParameterValue dependencyValue) {
				//TODO: implement the dependency's update method
				return true;
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of values that has been removed from the dependent and dependency 
			 * parameter since last expansion as a result of unbinding a value from 
			 * the dependency parameter. 
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true. To support remove
			 * behavior in pattern implementations this method would be overridden. In
			 * most cases the implementation of this method would be very much like the
			 * method variant with the types transposed.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			public boolean update(PatternParameterValue.Maintained value,
					PatternParameterValue.Removed dependencyValue) {
				//TODO: implement the dependency's update method
				return true;
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of values that has been removed from the dependent and dependency 
			 * parameter since last expansion as a result of unbinding a value from 
			 * the dependent parameter. 
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true. To support remove
			 * behavior in pattern implementations this method woul be overridden. In
			 * most cases the implementation of this method would be very much like the
			 * method variant with the types transposed.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			public boolean update(PatternParameterValue.Removed value,
					PatternParameterValue.Maintained dependencyValue) {
				//TODO: implement the dependency's update method
				return true;
			}
		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		private class Entite_NomTableDependency extends
				AbstractPatternDependency {
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			private Entite_NomTableDependency(
					AbstractPatternParameter dependency) {
				super(Entite.this, dependency);
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of new values that has been added to the dependent and dependency 
			 * parameter since last expansion as a result of binding a value to either 
			 * the dependent or dependency parameter. In a reapply scenerio, it gets 
			 * called for each pair of existing values bound to the parameters.
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 */
			public boolean update(PatternParameterValue value,
					PatternParameterValue dependencyValue) {
				Class inCl = (Class) value.getValue();
				StringExpression inTableName = (StringExpression) dependencyValue.getValue();
				
				Stereotype st = inCl.getAppliedStereotype("ProtoAuchan::metier");
				if (st == null) {
					st = inCl.getApplicableStereotype("ProtoAuchan::metier");
					inCl.applyStereotype(st);
				}
				inCl.setValue(st, "table", inTableName.getName());
				return true;
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of values that has been removed from the dependent and dependency 
			 * parameter since last expansion as a result of unbinding a value from 
			 * the dependency parameter. 
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true. To support remove
			 * behavior in pattern implementations this method would be overridden. In
			 * most cases the implementation of this method would be very much like the
			 * method variant with the types transposed.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			public boolean update(PatternParameterValue.Maintained value,
					PatternParameterValue.Removed dependencyValue) {
				//TODO: implement the dependency's update method
				return true;
			}

			/**
			 * This method gets called during a pattern expansion for each pair 
			 * of values that has been removed from the dependent and dependency 
			 * parameter since last expansion as a result of unbinding a value from 
			 * the dependent parameter. 
			 *
			 * Update the dependency using the dependent and dependency values as
			 * provided. This is a hot-spot method and the default behavior if not
			 * overridden is to do nothing more than return true. To support remove
			 * behavior in pattern implementations this method woul be overridden. In
			 * most cases the implementation of this method would be very much like the
			 * method variant with the types transposed.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			public boolean update(PatternParameterValue.Removed value,
					PatternParameterValue.Maintained dependencyValue) {
				//TODO: implement the dependency's update method
				return true;
			}
		}

	}

}
